use Config;
use File::Basename qw(basename dirname);
chdir(dirname($0));

$perl = shift(@ARGV);

$use = "use lib qw(\n\t" . join("\n\t", @ARGV) . ");\n";

($file = basename($0)) =~ s/\.PL$//;
$file =~ s/\.pl$//
	if ($Config{'osname'} eq 'VMS' or
	    $Config{'osname'} eq 'OS2');  # "case-forgiving"
open OUT,">$file" or die "Can't create $file: $!";
chmod(0755, $file);
print "Extracting $file (with variable substitutions)\n";

print OUT <<"!GROK!THIS!";
#!$perl -w

#
# Warning: File automatically generated. Any changes made here
# will be lost.
#

$use

!GROK!THIS!
print OUT <<'!NO!SUBS!';

=head1 NAME

test-parser

=head1 SYNOPSIS

test-parser filename

=head1 DESCRIPTION

Test jacket code for debugging the meta tag parser.

=cut

use strict;

use BIDM;
use BIDM::Webpage;
use LWP::RobotUA;
use MTk;
use Nexus;

#eval {
    &main;
#};

if ($@)
{
    print "$0 failed:\n\t$@\n";
    exit(1);
}


exit(0);

sub main
{
    my($src_file, $bidm_tagset, $page, $user_agent, $url);

    if (@ARGV == 1)
    {
	($src_file) = (@ARGV);
    }
    else
    {
	die "Usage: $0 src_file\n";
    }

    if ($src_file =~ /^http/)
    {
	$url = $src_file;
    }
    else
    {
	if ($src_file !~ /^\//)
	{
	    my($pwd);
	    chop($pwd = `pwd`);
	    $src_file =  $pwd . '/' . $src_file;
	}
	$url = "file://localhost$src_file";
    }

    $page = new BIDM::Webpage($url);

    $user_agent = new LWP::RobotUA("RIB/0.1", "olson\@mcs.anl.gov");

    #
    # For debugging, set the delay to zero. For production, set to
    # something else.
    #
    $user_agent->delay(0);
    $user_agent->use_eval(1);

    $bidm_tagset = $page->retrieve_metadata($user_agent);
#    print "Got tagset $bidm_tagset\n";
#    $bidm_tagset->print();
    my $t1 = Nexus::wallclock();
    my $obj = $bidm_tagset->parse();
    my $t2 = Nexus::wallclock();

    $obj->walk();

    my $elap = $t2 - $t1;
    print "exiting, elap=$elap\n";
}

package BIDM::RIGObject;
sub walk
{
    my($self) = @_;
    print "RIG walk $self\n";
}

package BIDM::RIGObject::Asset;
sub walk
{
    my($self) = @_;
    my($name, $k);
    print "Asset walk $self\n";

    ($name) = $self->TitleLine();
    print "name=$name\n";

    for $k ($self->Keyword())
    {
	print "Keyword: $k\n";
    }
    print "Abstract:\n---\n", $self->Abstract(), "\n---\n";
}

package BIDM::RIGObject::Organization;
sub walk
{
    my($self) = @_;
    print "Organization walk $self\n";
}

package BIDM::RIGObject::Library;
sub walk
{
    my($self) = @_;
    print "Library walk $self\n";
}
!NO!SUBS!
