package BIDM::RIGObject::Organization;

=head1 NAME

BIDM::RIGObject::Organization

=head1 DESCRIPTION

=cut

use strict;

use BIDM::RIGObject;
use BIDM::ClassDefinition;

use vars qw(@ISA);

@ISA = qw(BIDM::RIGObject);

my $ClassName = "Organization";
my $ClassDefinition = new BIDM::ClassDefinition($ClassName);

sub superclass
{
    return "BIDM::RIGObject";
}

sub new
{
    my($class) = @_;
    my($self);

    $self = new BIDM::RIGObject();

    bless($self, $class);

    $self->class_name($ClassName);
    $self->class_definition($ClassDefinition);

    return $self;

}

sub map_attribute_name
{
    my($self, $name) = @_;
    my($cname);

#     if (!defined($MapsDefined))
#     {
# 	&_define_maps();
#     }

#    $cname = $CanonicalAttribute{$name};

    if (defined($cname))
    {
	return $cname;
    }
    else
    {
	return $self->BIDM::RIGObject::map_attribute_name($name);
    }
}

sub map_relationship_name
{
    my($self, $name) = @_;
    my($cname);

#     if (!defined($MapsDefined))
#     {
# 	&_define_maps();
#     }

#    $cname = $CanonicalRelationship{$name};

    if (defined($cname))
    {
	return $cname;
    }
    else
    {
	return $self->BIDM::RIGObject::map_relationship_name($name);
    }
}

1;
__END__

#
# Create the lower-case-to-canonical-name maps for the attributes
# and relationships of this object.
#
sub _define_maps
{
    my($name, $cname);

    $MapsDefined = 1;
    
    for $cname (@Attributes)
    {
	$name = "\L$cname";
	$CanonicalAttribute{$name} = $cname;
    }
    
    for $cname (@Relationships)
    {
	$name = "\L$cname";
	$CanonicalRelationship{$name} = $cname;
    }
    
}

sub Address { shift->_elem('Address', @_); }
sub Email { shift->_elem('Email', @_); }
sub Fax { shift->_elem('Fax', @_); }
sub Telephone { shift->_elem('Telephone', @_); }

@Attributes = (
	'Address',
	'Email',
	'Fax',
	'Telephone',
);

@OptionalAttributes = (
	'Email',
	'Fax',
	'Telephone',
);

@RequiredAttributes = (
	'Address',
);

@Relationships = (
);

1;
