package MTk::DBTable::Asset;

@ISA = qw(MTk::DBTable HTML::Parser);

use BIDM::Webpage;
use BIDM::Tagset;
use BIDM::Tag;

sub new
{
    my($class, $key, $db) = @_;
    my($self);

    $self = MTk::DBTable->new("Asset");

    $self->{_buf} = '';

    $self->key($key);
    $self->db($db);

    bless($self, $class);

    return $self;
}

#
# Ahh, finally some real guts
#
# Snag the metadata for this asset from its host.
#
sub retrieve_metadata
{
    my($self, $user_agent) = @_;
    my($url);
    my($page, $tagset, $last_retrieval, $response);

    $url = $self->field_value('id');
    print "Fetching url $url\n";

    $page = new BIDM::Webpage($url);

    $last_retrieval = $self->field_value('last_retrieval');

    ($tagset, $response) = $page->retrieve_metadata($user_agent, $last_retrieval);

    return ($tagset, $response);
}

=head2 $asset->store_tagset($tagset)

Store the tagset in the database, and update the last_retrieval and
last_modified fields in the Asset record.

=cut

sub store_tagset
{
    my($self, $tagset) = @_;

    $self->field_value('last_retrieval', $tagset->response->date());
    $self->field_value('last_modified', $tagset->response->last_modified());
    if (!defined($expval = $tagset->response->expires()))
    {
	$expval = -1;
    }
    $self->field_value('expires', $expval);
    $self->store();
    $tagset->store_in_db($self->db(), $self->field_value('id'));
}

sub key_field
{
    return "id";
}

1;
